<template>
  <div class="header_bottom">
    <div class="header_bottom-body-wrapper container">
      <div
        class="header_bottom-body flex">
        <div class="flex flex-middle flex-center header_bottom-col header_bottom-type">
          <BSwitch
            @click.native="changeNetwork"
            :checked="isDemo"
            :loading="loading"
            disabled
            background="#f2a314"
            :activeText="$t('header.demo')"
            :inactiveText="$t('header.live')"></BSwitch>
        </div>
        <div class="header_bottom-col flex flex-middle">
          <div class="header_bottom-online">
            <img
              class="icon"
              src="~/static/icons/users_online.png"
              alt="">
            <div class="header_bottom-online-count">{{online}}</div>
          </div>
          <div
            class="header_bottom-timer flex flex-middle flex-center"
            :class="'header_bottom-timer-coolDown-'+coolDown">
          <span class="active">
            {{time}}
          </span>
            <span class="dot_wrapper">
            <span
              class="dot"
              :class="ttl!==0 ? 'dot_animate' : ''"></span>
          </span>
          </div>
          <div class="header_bottom-sound">
            <Btn plain>
              <img
                class="icon"
                src="~/static/icons/mute-speakers.png"
                alt="">
            </Btn>
          </div>
        </div>
      </div>
    </div>
    <ChangeNetwork
      @checked="(type) => checked = type"
      @close="checked=isDemo"
      :checked="!checked"
      ref="changeNetwork"></ChangeNetwork>
  </div>
</template>

<script>
  import BSwitch from '~/components/UI/Switch';
  import Btn from '~/components/UI/Btn';
  import Ws from '~/services/ws';
  import ifvisible from 'ifvisible.js';

  import ChangeNetwork from './TheChangeNetwork';
  import {mapState} from 'vuex';

  export default {
    name: "TheHeader_bottom",
    data() {
      return {
        coolDown: '',
        time: '00:00',
        ttl: 0,
        interval: null,
        online: 0,
        connected: false,
        checked: false,
        canCheckWaiting: false,
        idleChecking: true,
        idleInterval: null,
        loading: false,
        idleTimer: null
      }
    },
    components: {
      BSwitch,
      Btn,
      ChangeNetwork,
    },
    computed: mapState({
      pubKey: state => state.wallet.publicKey,
      currentGame: state => state.game.currentGame,
      isDemo: state => !state.common.demo,
      isAuth: state => state.user.isAuth,
      waitingState: state => state.common.waiting,
      gameSettings: state => state.game.settings
    }),
    methods: {
      changeNetwork({showDeposit = false} = {}) {
        this.$refs['changeNetwork'].show(true, showDeposit);
        this.ga('switch');
      },
      secondsLeft(t1, t2) {
        const time = Math.abs(t1 - t2) / 1000 > 60 ? 0 : Math.abs(t1 - t2) / 1000;
        return time === 0 ? 0 : 60 - Math.floor(time % 60);
      },
      wsInit() {
        Ws.on('online', msg => {
          !this.connected && Ws.on('connect', msg => {
            this.connected = true;
          });
          if (!msg) return;
          this.online = msg.payload;
        });
        Ws.on('timesync', msg => {
          if (!msg || !this.currentGame) return;
          if (!this.idleTimer && Math.abs((msg.payload.timestamp - new Date().getTime()) / 1000) > (this.gameSettings.ttl * 0.5)) {
            this.$store.dispatch('common/clockTrouble', true);
          } else {
            this.$store.dispatch('common/clockTrouble', false);
          }
          this.ttl = this.secondsLeft(this.currentGame.timestamp, new Date().getTime());
          if (!this.interval) this.startTimer();
        });
        Ws.on('logendgame', msg => {
          if (!msg || !this.currentGame) return;
          this.ttl = this.secondsLeft(this.currentGame.timestamp, msg.payload.timestamp || new Date().getTime());
          if (!this.interval) this.startTimer();
        });
        Ws.on('logstartgame', msg => {
          if (!this.currentGame.house_seed_hash) {
            this.ttl = this.secondsLeft(this.currentGame.timestamp, msg.payload.timestamp || new Date().getTime());
            if (!this.interval) this.startTimer();
          }
        });
      },
      startWaiting() {
        this.idleChecking && this.$store.dispatch('common/waitingState', true);
        this.idleChecking = false;
        if (!this.idleInterval) this.idleInterval = setInterval(_ => {
          clearInterval(this.idleInterval);
          this.idleChecking = true;
          this.idleInterval = null;
        }, 5000);
      },
      startTimer() {
        this.interval = setInterval(_ => {
          if (this.ttl > 0) this.ttl += -1;
          if (this.ttl > 0) {
            this.waitingState && this.$store.dispatch('common/waitingState', false);
            this.coolDown = '';
            this.time = '00:' + (this.ttl <= 9 ? '0' + this.ttl : this.ttl);
            if (this.ttl < 31) this.coolDown = '50';
            if (this.ttl < 10) this.coolDown = '0';
          } else {
            this.ttl = 0;
          }
          if (this.ttl === 0) {
            if (this.canCheckWaiting) this.startWaiting();
            this.time = '00:00';
          }
        }, 1000);
      },
      endTimer() {
        clearInterval(this.interval);
        this.interval = null;
      },
      initIdleManager() {
        ifvisible.on("idle", () => {
          this.idleTimer = new Date().getTime();
          this.$store.dispatch('common/clockTrouble', false);
        });

        ifvisible.on("wakeup", () => {
          this.$store.dispatch('common/clockTrouble', false);
          const now = new Date().getTime();
          if (now - this.idleTimer > 10000) {
            this.$store.dispatch('common/changeGameType', this.$store.state.common.demo);
            this.idleTimer = null;
          }
        });
      }
    },
    watch: {
      'isDemo': {
        immediate: true,
        handler: function () {
          this.checked = this.isDemo;
        },
      },
      'pubKey': function () {
        if (this.pubKey || localStorage.getItem('public')) {
          this.wsInit();
        }
      },
      'currentGame': function () {
        if (this.currentGame.timestamp) {
          //console.log(this.currentGame.timestamp - new Date().getTime(), this.currentGame.timestamp - this.serverTime);
          this.ttl = this.secondsLeft(this.currentGame.timestamp, new Date().getTime());
          if (!this.interval) this.startTimer();
        }
      }
    },
    mounted() {
      if (this.currentGame.timestamp) {
        this.ttl = this.secondsLeft(this.currentGame.timestamp, new Date().getTime());
      }
      this.$root.$refs['header_bottom'] = this;
      this.wsInit();
      this.initIdleManager();
    }
  }
</script>
